@echo off
cls
if "%1"=="" goto usage

:main
cls
echo.
echo Main Menu
echo.
echo 1) Compile %1.ASM
echo 2) Edit %1.ASM
echo 3) Print %1.ASM
echo 4) Read the documentation
echo 5) Shell to DOS
echo 6) Exit
echo.
choice /c:123456 /n "Choose one (1-6): "
if errorlevel 6 goto done
if errorlevel 5 goto shelldos
if errorlevel 4 goto readdoc
if errorlevel 3 goto print
if errorlevel 2 goto edit
if errorlevel 1 goto compile


:compile
cls
echo.
echo Compile Options
echo.
echo 1) Compile %1.ASM for OShell-82
echo 2) Compile %1.ASM for ASH
echo 3) Return to the Main Menu
echo.
choice /c:123 /n "Choose one (1-3): "
if errorlevel 3 goto main
if errorlevel 2 goto ash
if errorlevel 1 goto oshell

:oshell
cls
echo.
echo OShell-82 Compile Options
echo.
echo 1) Don't pause after each step during compile
echo 2) Pause after each step
echo 3) Return to the Compile Options Menu
echo.
choice /c:123 /n "Choose one (1-3): "
if errorlevel 3 goto compile
if errorlevel 2 goto pauseoshell
if errorlevel 1 goto nopauseoshell

:nopauseoshell
erase offti-82.h
copy /b part1.h+part2.osh+part3.h offti-82.h
call oshell82 %1
goto finish

:pauseoshell
erase offti-82.h
copy /b part1.h+part2.osh+part3.h offti-82.h
call oshell82 %1 PauseComp
goto finish

:ash
cls
echo.
echo ASH Compile Options
echo.
echo 1) Don't pause after each step during compile
echo 2) Pause after each step
echo 3) Return to the Compile Options Menu
echo.
choice /c:123 /n "Choose one (1-3): "
if errorlevel 3 goto compile
if errorlevel 2 goto pauseash
if errorlevel 1 goto nopauseash

:nopauseash
erase offti-82.h
copy /b part1.h+part2.ash+part3.h offti-82.h
call ash %1
goto finish

:pauseash
erase offti-82.h
copy /b part1.h+part2.ash+part3.h offti-82.h
call ash %1 PauseComp
:finish
cls
echo.
echo Finish Compile Options
echo.
echo 1) Erase %1.OBJ and %1.LST
echo 2) Erase %1.OBJ only
echo 3) View %1.LST
echo 4) Keep %1.OBJ and %1.LST
echo.
choice /c:1234 /n "Choose one (1-4): "
if errorlevel 4 goto main
if errorlevel 3 goto viewlst
if errorlevel 2 goto erase2
if errorlevel 1 goto erase1

:erase1
erase %1.LST
:erase2
erase %1.OBJ
goto main

:viewlst
browse %1.LST
goto finish


:edit
edit %1.ASM
goto main


:print
cls
echo.
echo Print Menu
echo.
echo 1) Begin printing of %1.ASM (make sure you have the printer ready)
echo 2) Return to the Main Menu
echo.
choice /c:12 /n "Choose one (1-2): "
if errorlevel 2 goto main
cls
echo.
echo Now printing %1.ASM
echo.
type %1.ASM>prn
goto main


:readdoc
cls
echo.
echo Documentation Menu
echo.
type aodkd.txt
echo 2) Z80 Hardware Reference (TASM programming)
echo 3) Z80 Instruction Set Summary (TASM programming)
echo 4) Z80 Timing Table (Clock Cycles)
echo 5) Programmers' Guide to the 82 Ports
echo 6) Programmers' Guide to the 82 ROM
echo 7) Programmers' Guide to the 82 RAM
echo 8) Programmers' Guide to the 82 Variables
echo 9) Return to the Main Menu
echo.
choice /c:123456789 /n "Choose one (1-9): "
if errorlevel 9 goto main
if errorlevel 8 goto 82VARdoc
if errorlevel 7 goto 82RAMdoc
if errorlevel 6 goto 82ROMdoc
if errorlevel 5 goto 82PORTSdoc
if errorlevel 4 goto Z80TIMEdoc
if errorlevel 3 goto ISSdoc
if errorlevel 2 goto HREFdoc
if errorlevel 1 goto A2Odoc

:HREFdoc
browse z80href.txt
goto readdoc

:ISSdoc
browse z80iss.txt
goto readdoc

:Z80TIMEdoc
browse z80time.txt
goto readdoc

:82PORTSdoc
browse 82-ports.txt
goto readdoc

:82ROMdoc
browse 82-rom.txt
goto readdoc

:82RAMdoc
browse 82-ram.txt
goto readdoc

:82VARdoc
browse 82-var.txt
goto readdoc

:A2Odoc
cls
echo.
type aodkm.txt
echo.
type aodkd.txt
echo 2) Multi_Key Routine Documentation
echo 3) SpriteDraw Documentation
echo 4) SpriteDraw Statistics (SPRTSTAT.TXT)
echo 5) The Official TI-82.H Include File (Reference use only)
echo 6) Graphics Routines Include File (Reference use only)
echo 7) Return to the Documentation Menu
echo 8) Return to the Main Menu
echo.
choice /c:12345678 /n "Choose one (1-8): "
if errorlevel 8 goto main
if errorlevel 7 goto readdoc
if errorlevel 6 goto GRAPHdoc
if errorlevel 5 goto OFFTIdoc
if errorlevel 4 goto SPRTSTATdoc
if errorlevel 3 goto SPRITEdoc
if errorlevel 2 goto MULTIdoc
if errorlevel 1 goto READMEdoc

:READMEdoc
browse readme.txt
goto A2Odoc

:MULTIdoc
browse multikey.txt
goto A2Odoc

:SPRITEdoc
browse sprite.txt
goto A2Odoc

:SPRTSTATdoc
browse sprtstat.txt
goto A2Odoc

:OFFTIdoc
browse offti-82.h
goto A2Odoc

:GRAPHdoc
browse graph.inc
goto A2Odoc


:shelldos
cls
echo.
echo Type EXIT to return to COMPILE
command
goto main


:usage
echo.
echo Usage:
echo.
echo    %0 [filename]
echo.
echo Where [filename] is the assembly source file (leave off the ASM extension).
echo.
goto done2
:done
cls
:done2
