; Multi_Key Test program v1.0.  This shows off the capabilities of Multi_Key.

; Written by Thomas J. Hruska (C) 1997 Shining Light Productions

#include "offti-82.h"
#include "multikey.h"

.ORG 0
#IFDEF OSHELL82
.DB "Multi_Key Test",0
#ENDIF

  ROM_CALL(CLEARLCD)
  ld hl,$0000
  ld (CURSOR_POS),hl
  set 3,(IY+05)
  ld hl,Title
  ld de,(PROGRAM_ADDR)
  add hl,de
  ROM_CALL(D_ZT_STR)
  res 3,(IY+05)
  ld hl,$0003
  ld (CURSOR_POS),hl
  ld hl,Main
  ld de,(PROGRAM_ADDR)
  add hl,de
  ROM_CALL(D_ZT_STR)
  
KeyLoop:
  Multi_Key(KEY_24)
  CALL_NZ(LeftPressed)
  Multi_Key(KEY_24)
  CALL_Z(LeftReleased)
  Multi_Key(KEY_25)
  CALL_NZ(UpPressed)
  Multi_Key(KEY_25)
  CALL_Z(UpReleased)
  Multi_Key(KEY_26)
  CALL_NZ(RightPressed)
  Multi_Key(KEY_26)
  CALL_Z(RightReleased)
  Multi_Key(KEY_34)
  CALL_NZ(DownPressed)
  Multi_Key(KEY_34)
  CALL_Z(DownReleased)
  Multi_Key(KEY_22)
  CALL_NZ(MODEPressed)
  Multi_Key(KEY_22)
  CALL_Z(MODEReleased)
  Multi_Key(KEY_45)
  ret nz
  JUMP_(KeyLoop)

LeftPressed:
  ld hl,$0803
DispPressed:
  ld (CURSOR_POS),hl
  ld hl,KeyOn
  ld de,(PROGRAM_ADDR)
  add hl,de
  ROM_CALL(D_ZT_STR)
  ret
UpPressed:
  ld hl,$0804
  jr DispPressed
RightPressed:
  ld hl,$0805
  jr DispPressed
DownPressed:
  ld hl,$0806
  jr DispPressed
MODEPressed:
  ld hl,$0807
  jr DispPressed

LeftReleased:
  ld hl,$0803
DispReleased:
  ld (CURSOR_POS),hl
  ld hl,KeyOff
  ld de,(PROGRAM_ADDR)
  add hl,de
  ROM_CALL(D_ZT_STR)
  ret
UpReleased:
  ld hl,$0804
  jr DispReleased
RightReleased:
  ld hl,$0805
  jr DispReleased
DownReleased:
  ld hl,$0806
  jr DispReleased
MODEReleased:
  ld hl,$0807
  jr DispReleased

#include "multikey.inc"

Title:
.DB " Multi-Key Test "
.DB "By Thomas Hruska"
.DB "  CLEAR  quits  ",0

Main:
.DB "Left :          "
.DB "Up   :          "
.DB "Right:          "
.DB "Down :          "
.DB "MODE :          ",0

KeyOn:  .DB "Pressed ",0
KeyOff: .DB "Released",0

.END
